""" Implement a design pattern for a multifunction that delegates to another
multifunction and gets back control if the delegate does not define a handler.
This avoids writing isinstance-if-orgies in handlers
"""


def delegate(Delegate, *args, **kwargs):
    assert(isinstance(Delegate, type))
    assert(Delegate.expr == Delegate.undefined)

    class MyDelegate(Delegate):
        def __init__(self, *a, **ka):
            Delegate.__init__(self, *a, **ka)

        def expr(s, *a, **ka):
            s._back(*a, **ka)

    def _handler(s, *a, **ka):
        delegate_instance = MyDelegate(*args, **kwargs)
        delegate_instance._back = s
        return delegate_instance(*a, **ka)

    return _handler
